using System.Numerics;
using Nethereum.ABI.FunctionEncoding.Attributes;

namespace Managing.ABI.GmxV2.ExchangeRouter.ContractDefinition
{
    public partial class CreateWithdrawalParams : CreateWithdrawalParamsBase
    {
    }

    public class CreateWithdrawalParamsBase
    {
        [Parameter("address", "receiver", 1)] public virtual string Receiver { get; set; }

        [Parameter("address", "callbackContract", 2)]
        public virtual string CallbackContract { get; set; }

        [Parameter("address", "uiFeeReceiver", 3)]
        public virtual string UiFeeReceiver { get; set; }

        [Parameter("address", "market", 4)] public virtual string Market { get; set; }

        [Parameter("address[]", "longTokenSwapPath", 5)]
        public virtual List<string> LongTokenSwapPath { get; set; }

        [Parameter("address[]", "shortTokenSwapPath", 6)]
        public virtual List<string> ShortTokenSwapPath { get; set; }

        [Parameter("uint256", "minLongTokenAmount", 7)]
        public virtual BigInteger MinLongTokenAmount { get; set; }

        [Parameter("uint256", "minShortTokenAmount", 8)]
        public virtual BigInteger MinShortTokenAmount { get; set; }

        [Parameter("bool", "shouldUnwrapNativeToken", 9)]
        public virtual bool ShouldUnwrapNativeToken { get; set; }

        [Parameter("uint256", "executionFee", 10)]
        public virtual BigInteger ExecutionFee { get; set; }

        [Parameter("uint256", "callbackGasLimit", 11)]
        public virtual BigInteger CallbackGasLimit { get; set; }
    }
}